diff -urN ../VisualBoyAdvance-1.7.2/src/sdl/debugger.cpp ./src/sdl/debugger.cpp
--- ../VisualBoyAdvance-1.7.2/src/sdl/debugger.cpp	2004-05-13 23:13:14 +0900
+++ ./src/sdl/debugger.cpp	2006-08-25 23:00:49 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -16,18 +16,23 @@
 // along with this program; if not, write to the Free Software Foundation,
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+// Parts adapted from VBA-H (VBA for Hackers) by LabMaster
+
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <ctype.h>
 
-#include "GBA.h"
-#include "Port.h"
-#include "armdis.h"
-#include "elf.h"
-#include "exprNode.h"
+#include "../GBA.h"
+#include "../Port.h"
+#include "../armdis.h"
+#include "../elf.h"
+#include "../exprNode.h"
 
 extern bool debugger;
 extern int emulating;
+extern void sdlWriteState(int num);
+extern void sdlReadState(int num);
 
 extern struct EmulatedSystem emulator;
 
@@ -53,6 +58,13 @@
   u32 address;
   u32 value;
   int size;
+
+  u32 cond_address;
+  char cond_rel;
+  u32 cond_value;
+  int cond_size;
+  bool ia1;
+  bool ia2;
 };
 
 struct DebuggerCommand {
@@ -62,73 +74,116 @@
   char *syntax;
 };
 
-void debuggerContinueAfterBreakpoint();
-
-void debuggerHelp(int,char **);
-void debuggerNext(int,char **);
-void debuggerContinue(int, char **);
-void debuggerRegisters(int, char **);
-void debuggerBreak(int, char **);
-void debuggerBreakDelete(int, char **);
-void debuggerBreakList(int, char **);
-void debuggerBreakArm(int, char **);
-void debuggerBreakWriteClear(int, char **);
-void debuggerBreakThumb(int, char **);
-void debuggerBreakWrite(int, char **);
-void debuggerDebug(int, char **);
-void debuggerDisassemble(int, char **);
-void debuggerDisassembleArm(int, char **);
-void debuggerDisassembleThumb(int, char **);
-void debuggerEditByte(int, char **);
-void debuggerEditHalfWord(int, char **);
-void debuggerEdit(int, char **);
-void debuggerIo(int, char **);
-void debuggerLocals(int, char **);
-void debuggerMemoryByte(int, char **);
-void debuggerMemoryHalfWord(int, char **);
-void debuggerMemory(int, char **);
-void debuggerPrint(int, char **);
-void debuggerQuit(int, char **);
-void debuggerSetRadix(int, char **);
-void debuggerSymbols(int, char **);
-void debuggerVerbose(int, char **);
-void debuggerWhere(int, char **);
-
-DebuggerCommand debuggerCommands[] = {
-  { "?", debuggerHelp,        "Shows this help information. Type ? <command> for command help", "[<command>]" },
-  { "ba", debuggerBreakArm,   "Adds an ARM breakpoint", "<address>" },
-  { "bd", debuggerBreakDelete,"Deletes a breakpoint", "<number>" },
-  { "bl", debuggerBreakList,  "Lists breakpoints" },
+unsigned int SearchStart = 0xFFFFFFFF;
+unsigned int SearchMaxMatches = 5;
+u8 SearchData [64]; // It doesn't make much sense to search for more than 64 bytes
+unsigned int SearchLength = 0;
+unsigned int SearchResults;
+
+static void debuggerContinueAfterBreakpoint();
+void debuggerDoSearch();
+unsigned int AddressToGBA(u8* mem);
+
+static void debuggerHelp(int,char **);
+static void debuggerNext(int,char **);
+static void debuggerContinue(int, char **);
+static void debuggerRegisters(int, char **);
+static void debuggerBreak(int, char **);
+static void debuggerBreakDelete(int, char **);
+static void debuggerBreakList(int, char **);
+static void debuggerBreakArm(int, char **);
+static void debuggerBreakThumb(int, char **);
+static void debuggerBreakChange(int, char **);
+static void debuggerBreakChangeClear(int, char **);
+static void debuggerBreakWriteClear(int, char **);
+static void debuggerBreakWrite(int, char **);
+static void debuggerDebug(int, char **);
+static void debuggerDisassemble(int, char **);
+static void debuggerDisassembleArm(int, char **);
+static void debuggerDisassembleThumb(int, char **);
+static void debuggerEditByte(int, char **);
+static void debuggerEditHalfWord(int, char **);
+static void debuggerEditRegister(int, char **);
+static void debuggerEdit(int, char **);
+static void debuggerFileDisassemble(int, char **);
+static void debuggerFileDisassembleArm(int, char **);
+static void debuggerFileDisassembleThumb(int, char **);
+static void debuggerFindText(int, char **);
+static void debuggerFindHex(int, char **);
+static void debuggerFindResume(int, char **);
+static void debuggerIo(int, char **);
+static void debuggerLast(int, char **);
+static void debuggerLocals(int, char **);
+static void debuggerMemoryByte(int, char **);
+static void debuggerMemoryHalfWord(int, char **);
+static void debuggerMemory(int, char **);
+static void debuggerPrint(int, char **);
+static void debuggerQuit(int, char **);
+static void debuggerSetRadix(int, char **);
+static void debuggerSymbols(int, char **);
+static void debuggerVerbose(int, char **);
+static void debuggerWhere(int, char **);
+
+static void debuggerReadState(int, char **);
+static void debuggerWriteState(int, char **);
+static void debuggerDumpLoad(int, char**);
+static void debuggerDumpSave(int, char**);
+static void debuggerCondValidate(int n, char **args, int start);
+static bool debuggerCondEvaluate(int num);
+static void debuggerCondBreakThumb(int, char **);
+static void debuggerCondBreakArm(int, char **);
+
+static DebuggerCommand debuggerCommands[] = {
+  { "?", debuggerHelp,        "Show this help information. Type ? <command> for command help", "[<command>]" },
+  { "ba", debuggerBreakArm,   "Add an ARM breakpoint", "<address>" },
+  { "bd", debuggerBreakDelete,"Delete a breakpoint", "<number>" },
+  { "bl", debuggerBreakList,  "List breakpoints" },
+  { "bpc", debuggerBreakChange, "Break on change", "<address> <size>" },
+  { "bpcc", debuggerBreakChangeClear, "Clear break on change", "[<address> <size>]" },
   { "bpw", debuggerBreakWrite, "Break on write", "<address> <size>" },
-  { "bpwc", debuggerBreakWriteClear, "Clear break on write", NULL },
-  { "break", debuggerBreak,    "Adds a breakpoint on the given function", "<function>|<line>|<file:line>" },
-  { "bt", debuggerBreakThumb, "Adds a THUMB breakpoint", "<address>" },
-  { "c", debuggerContinue,    "Continues execution" , NULL },
-  { "d", debuggerDisassemble, "Disassembles instructions", "[<address> [<number>]]" },
-  { "da", debuggerDisassembleArm, "Disassembles ARM instructions", "[<address> [<number>]]" },
-  { "dt", debuggerDisassembleThumb, "Disassembles THUMB instructions", "[<address> [<number>]]" },
+  { "bpwc", debuggerBreakWriteClear, "Clear break on write", "[<address> <size>]" },
+  { "break", debuggerBreak,    "Add a breakpoint on the given function", "<function>|<line>|<file:line>" },
+  { "bt", debuggerBreakThumb, "Add a THUMB breakpoint", "<address>" },
+  { "c", debuggerContinue,    "Continue execution" , NULL },
+  { "cba", debuggerCondBreakArm, "Add a conditional ARM breakpoint", "<address> $<address>|R<register> <comp> <value> [<size>]\n<comp> either ==, !=, <, >, <=, >=\n<size> either b, h, w" },
+  { "cbt", debuggerCondBreakThumb, "Add a conditional THUMB breakpoint", "<address> $<address>|R<register> <comp> <value> [<size>]\n<comp> either ==, !=, <, >, <=, >=\n<size> either b, h, w" },
+  { "d", debuggerDisassemble, "Disassemble instructions", "[<address> [<number>]]" },
+  { "da", debuggerDisassembleArm, "Disassemble ARM instructions", "[<address> [<number>]]" },
+  { "dload",debuggerDumpLoad, "Load raw data dump from file","<file> <address>"},
+  { "dsave",debuggerDumpSave, "Dump raw data to file","<file> <address> <size>"},
+  { "dt", debuggerDisassembleThumb, "Disassemble THUMB instructions", "[<address> [<number>]]" },
   { "eb", debuggerEditByte,   "Modify memory location (byte)", "<address> <hex value>" },
   { "eh", debuggerEditHalfWord,"Modify memory location (half-word)","<address> <hex value>" },
-  { "ew", debuggerEdit,       "Modify memory location (word)", "<address> <hex value" },
-  { "h", debuggerHelp,        "Shows this help information. Type h <command> for command help", "[<command>]" },
+  { "er", debuggerEditRegister,       "Modify register", "<register number> <hex value>" },
+  { "ew", debuggerEdit,       "Modify memory location (word)", "<address> <hex value>" },
+  { "fd", debuggerFileDisassemble, "Disassemble instructions to file", "<file> [<address> [<number>]]" },
+  { "fda", debuggerFileDisassembleArm, "Disassemble ARM instructions to file", "<file> [<address> [<number>]]" },
+  { "fdt", debuggerFileDisassembleThumb, "Disassemble THUMB instructions to file", "<file> [<address> [<number>]]" },
+  { "ft", debuggerFindText, "Search memory for ASCII-string.", "<start> [<max-result>] <string>" },
+  { "fh", debuggerFindHex, "Search memory for hex-string.", "<start> [<max-result>] <hex-string>" },
+  { "fr", debuggerFindResume, "Resume current search.", "[<max-result>]" },
+  { "h", debuggerHelp,        "Show this help information. Type h <command> for command help", "[<command>]" },
   { "io", debuggerIo,         "Show I/O registers status", "[video|video2|dma|timer|misc]" },
-  { "locals", debuggerLocals, "Shows local variables", NULL },
-  { "mb", debuggerMemoryByte, "Shows memory contents (bytes)", "<address>" },
-  { "mh", debuggerMemoryHalfWord, "Shows memory contents (half-words)", "<address>"},
-  { "mw", debuggerMemory,     "Shows memory contents (words)", "<address>" },
-  { "n", debuggerNext,        "Executes the next instruction", "[<count>]" },
+  { "last", debuggerLast,	  "Trigger the display of the last registers states", NULL },
+  { "load", debuggerReadState,	"Load a savegame", "<number>" },
+  { "locals", debuggerLocals, "Show local variables", NULL },
+  { "mb", debuggerMemoryByte, "Show memory contents (bytes)", "<address>" },
+  { "mh", debuggerMemoryHalfWord, "Show memory contents (half-words)", "<address>"},
+  { "mw", debuggerMemory,     "Show memory contents (words)", "<address>" },
+  { "n", debuggerNext,        "Execute the next instruction", "[<count>]" },
   { "print", debuggerPrint,   "Print the value of a expression (if known)", "[/x|/o|/d] <expression>" },
-  { "q", debuggerQuit,        "Quits the emulator", NULL },
-  { "r", debuggerRegisters,   "Shows ARM registers", NULL },
-  { "radix", debuggerSetRadix,   "Sets the print radix", "<radix>" },
+  { "q", debuggerQuit,        "Quit the emulator", NULL },
+  { "r", debuggerRegisters,   "Show ARM registers", NULL },
+  { "radix", debuggerSetRadix,   "Set the print radix", "<radix>" },
+  { "save", debuggerWriteState,	"Create a savegame", "<number>" },
   { "symbols", debuggerSymbols, "List symbols", "[<symbol>]" },
 #ifndef FINAL_VERSION
-  { "trace", debuggerDebug,       "Sets the trace level", "<value>" },
+  { "trace", debuggerDebug,       "Set the trace level", "<value>" },
 #endif
 #ifdef DEV_VERSION
   { "verbose", debuggerVerbose,     "Change verbose setting", "<value>" },
 #endif
-  { "where", debuggerWhere,   "Shows call chain", NULL },
+  { "where", debuggerWhere,   "Show the call chain (if available)", NULL },
   { NULL, NULL, NULL, NULL} // end marker
 };
 
@@ -139,7 +194,30 @@
 int debuggerBreakpointNumber = 0;
 int debuggerRadix = 0;
 
-void debuggerApplyBreakpoint(u32 address, int num, int size)
+extern u32 cpuPrefetch[2];
+
+#define ARM_PREFETCH \
+  {\
+    cpuPrefetch[0] = debuggerReadMemory(armNextPC);\
+    cpuPrefetch[1] = debuggerReadMemory(armNextPC+4);\
+  }
+
+#define THUMB_PREFETCH \
+  {\
+    cpuPrefetch[0] = debuggerReadHalfWord(armNextPC);\
+    cpuPrefetch[1] = debuggerReadHalfWord(armNextPC+2);\
+  }
+
+static void debuggerPrefetch()
+{
+  if(armState) {
+    ARM_PREFETCH;
+  } else {
+    THUMB_PREFETCH;
+  }
+}
+
+static void debuggerApplyBreakpoint(u32 address, int num, int size)
 {
   if(size)
     debuggerWriteMemory(address, (u32)(0xe1200070 | 
@@ -150,7 +228,7 @@
                           (u16)(0xbe00 | num));
 }
 
-void debuggerDisableBreakpoints()
+static void debuggerDisableBreakpoints()
 {
   for(int i = 0; i < debuggerNumOfBreakpoints; i++) {
     if(debuggerBreakpointList[i].size)
@@ -162,7 +240,7 @@
   }
 }
 
-void debuggerEnableBreakpoints(bool skipPC)
+static void debuggerEnableBreakpoints(bool skipPC)
 {
   for(int i = 0; i < debuggerNumOfBreakpoints; i++) {
     if(debuggerBreakpointList[i].address == armNextPC && skipPC)
@@ -174,12 +252,12 @@
   }  
 }
 
-void debuggerUsage(char *cmd)
+static void debuggerUsage(char *cmd)
 {
   for(int i = 0; ; i++) {
     if(debuggerCommands[i].name) {
       if(!strcmp(debuggerCommands[i].name, cmd)) {
-        printf("%s %s\t%s\n", 
+        printf("%s %s\n\n%s\n", 
                debuggerCommands[i].name, 
                debuggerCommands[i].syntax ? debuggerCommands[i].syntax : "",
                debuggerCommands[i].help);
@@ -192,9 +270,9 @@
   }  
 }
 
-void debuggerPrintBaseType(Type *t, u32 value, u32 location,
-                           LocationType type,
-                           int bitSize, int bitOffset)
+static void debuggerPrintBaseType(Type *t, u32 value, u32 location,
+                                  LocationType type,
+                                  int bitSize, int bitOffset)
 {
   if(bitSize) {
     if(bitOffset)
@@ -287,7 +365,7 @@
   }
 }
 
-char *debuggerPrintType(Type *t)
+static char *debuggerPrintType(Type *t)
 {
   char buffer[1024];  
   static char buffer2[1024];
@@ -307,12 +385,12 @@
   return t->name;
 }
 
-void debuggerPrintValueInternal(Function *, Type *, ELFBlock *, int, int, u32);
-void debuggerPrintValueInternal(Function *f, Type *t,
-                                int bitSize, int bitOffset,
-                                u32 objLocation, LocationType type);
+static void debuggerPrintValueInternal(Function *, Type *, ELFBlock *, int, int, u32);
+static void debuggerPrintValueInternal(Function *f, Type *t,
+				       int bitSize, int bitOffset,
+				       u32 objLocation, LocationType type);
 
-u32 debuggerGetValue(u32 location, LocationType type)
+static u32 debuggerGetValue(u32 location, LocationType type)
 {
   switch(type) {
   case LOCATION_memory:
@@ -325,31 +403,31 @@
   return 0;
 }
 
-void debuggerPrintPointer(Type *t, u32 value)
+static void debuggerPrintPointer(Type *t, u32 value)
 {
   printf("(%s)0x%08x", debuggerPrintType(t), value);
 }
 
-void debuggerPrintReference(Type *t, u32 value)
+static void debuggerPrintReference(Type *t, u32 value)
 {
   printf("(%s)0x%08x", debuggerPrintType(t), value);
 }
 
-void debuggerPrintFunction(Type *t, u32 value)
+static void debuggerPrintFunction(Type *t, u32 value)
 {
   printf("(%s)0x%08x", debuggerPrintType(t), value);
 }
 
-void debuggerPrintArray(Type *t, u32 value)
+static void debuggerPrintArray(Type *t, u32 value)
 {
   // todo
   printf("(%s[])0x%08x", debuggerPrintType(t->array->type), value);
 }
 
-void debuggerPrintMember(Function *f,
-                         Member *m,
-                         u32 objLocation,
-                         u32 location)
+static void debuggerPrintMember(Function *f,
+                                Member *m,
+                                u32 objLocation,
+                                u32 location)
 {
   int bitSize = m->bitSize;
   if(bitSize) {
@@ -392,7 +470,7 @@
     }  
 }
 
-void debuggerPrintStructure(Function *f, Type *t, u32 objLocation)
+static void debuggerPrintStructure(Function *f, Type *t, u32 objLocation)
 {
   printf("{");
   int count = t->structure->memberCount;
@@ -410,7 +488,7 @@
   printf("}");
 }
 
-void debuggerPrintUnion(Function *f, Type *t, u32 objLocation)
+static void debuggerPrintUnion(Function *f, Type *t, u32 objLocation)
 {
   // todo
   printf("{");
@@ -427,7 +505,7 @@
   printf("}");
 }
 
-void debuggerPrintEnum(Type *t, u32 value)
+static void debuggerPrintEnum(Type *t, u32 value)
 {
   int i;
   for(i = 0; i < t->enumeration->count; i++) {
@@ -440,9 +518,9 @@
   printf("(UNKNOWN VALUE) %d", value);
 }
 
-void debuggerPrintValueInternal(Function *f, Type *t,
-                                int bitSize, int bitOffset,
-                                u32 objLocation, LocationType type)
+static void debuggerPrintValueInternal(Function *f, Type *t,
+                                       int bitSize, int bitOffset,
+                                       u32 objLocation, LocationType type)
 {
   u32 value = debuggerGetValue(objLocation, type);
   if(!t) {
@@ -480,8 +558,9 @@
   }  
 }
 
-void debuggerPrintValueInternal(Function *f, Type *t, ELFBlock *loc,
-                                int bitSize, int bitOffset, u32 objLocation)
+static void debuggerPrintValueInternal(Function *f, Type *t, ELFBlock *loc,
+                                       int bitSize, int bitOffset, 
+                                       u32 objLocation)
 {
   LocationType type;  
   u32 location;
@@ -498,14 +577,14 @@
   debuggerPrintValueInternal(f, t, bitSize, bitOffset, location, type);
 }
 
-void debuggerPrintValue(Function *f, Object *o)
+static void debuggerPrintValue(Function *f, Object *o)
 {
   debuggerPrintValueInternal(f, o->type, o->location, 0, 0, 0);
   
   printf("\n");
 }
 
-void debuggerSymbols(int argc, char **argv)
+static void debuggerSymbols(int argc, char **argv)
 {
   int i = 0;
   u32 value;
@@ -550,7 +629,7 @@
   }
 }
 
-void debuggerSetRadix(int argc, char **argv)
+static void debuggerSetRadix(int argc, char **argv)
 {
   if(argc != 2)
     debuggerUsage(argv[0]);
@@ -578,7 +657,7 @@
   }
 }
 
-void debuggerPrint(int argc, char **argv)
+static void debuggerPrint(int argc, char **argv)
 {
   if(argc != 2 && argc != 3) {
     debuggerUsage(argv[0]);
@@ -647,7 +726,7 @@
   }
 }
 
-void debuggerHelp(int n, char **args)
+static void debuggerHelp(int n, char **args)
 {
   if(n == 2) {
     debuggerUsage(args[1]);
@@ -661,7 +740,7 @@
   }
 }
 
-void debuggerDebug(int n, char **args)
+static void debuggerDebug(int n, char **args)
 {
   if(n == 2) {
     int v = 0;
@@ -672,7 +751,7 @@
     debuggerUsage("trace");      
 }
 
-void debuggerVerbose(int n, char **args)
+static void debuggerVerbose(int n, char **args)
 {
   if(n == 2) {
     int v = 0;
@@ -683,13 +762,13 @@
     debuggerUsage("verbose");    
 }
 
-void debuggerWhere(int n, char **args)
+static void debuggerWhere(int n, char **args)
 {
   void elfPrintCallChain(u32);
   elfPrintCallChain(armNextPC);
 }
 
-void debuggerLocals(int n, char **args)
+static void debuggerLocals(int n, char **args)
 {
   Function *f = NULL;
   CompileUnit *u = NULL;
@@ -719,7 +798,7 @@
   }  
 }
 
-void debuggerNext(int n, char **args)
+static void debuggerNext(int n, char **args)
 {
   int count = 1;
   if(n == 2) {
@@ -729,8 +808,10 @@
     if(debuggerAtBreakpoint) {
       debuggerContinueAfterBreakpoint();
       debuggerEnableBreakpoints(false);
-    } else 
+    } else {
+      debuggerPrefetch();
       emulator.emuMain(1);
+    }
   }
   debuggerDisableBreakpoints();
   Function *f = NULL;
@@ -746,15 +827,16 @@
   debuggerRegisters(0, NULL);
 }
 
-void debuggerContinue(int n, char **args)
+static void debuggerContinue(int n, char **args)
 {
   if(debuggerAtBreakpoint)
     debuggerContinueAfterBreakpoint();
   debuggerEnableBreakpoints(false);
   debugger = false;
+  debuggerPrefetch();
 }
 
-void debuggerSignal(int sig,int number)
+/*extern*/ void debuggerSignal(int sig,int number)
 {
   switch(sig) {
   case 4:
@@ -765,12 +847,21 @@
     break;
   case 5:
     {
-      printf("Breakpoint %d reached\n", number);
-      debugger = true;
+      bool cond = debuggerCondEvaluate(number & 255);
+      if(cond) {
+        printf("Breakpoint %d reached\n", number);
+        debugger = true;
+      } else {
+        debuggerDisableBreakpoints();
+        debuggerPrefetch();
+        emulator.emuMain(1);
+        debuggerEnableBreakpoints(false);
+        return;
+      }
       debuggerAtBreakpoint = true;
       debuggerBreakpointNumber = number;
       debuggerDisableBreakpoints();
-      
+
       Function *f = NULL;
       CompileUnit *u = NULL;
       
@@ -788,7 +879,7 @@
   }
 }
 
-void debuggerBreakList(int, char **)
+static void debuggerBreakList(int, char **)
 {
   printf("Num Address  Type  Symbol\n");
   printf("--- -------- ----- ------\n");
@@ -799,13 +890,13 @@
   }
 }
 
-void debuggerBreakDelete(int n, char **args)
+static void debuggerBreakDelete(int n, char **args)
 {
   if(n == 2) {
     int n = 0;
     sscanf(args[1], "%d", &n);
-    printf("Deleting breakpoint %d (%d)\n", n, debuggerNumOfBreakpoints);
     if(n >= 0 && n < debuggerNumOfBreakpoints) {
+      printf("Deleting breakpoint %d (%d)\n", n, debuggerNumOfBreakpoints);
       n++;
       if(n < debuggerNumOfBreakpoints) {
         for(int i = n; i < debuggerNumOfBreakpoints; i++) {
@@ -819,11 +910,13 @@
       }
       debuggerNumOfBreakpoints--;
     }
+    else
+      printf("No breakpoints are set\n");
   } else
     debuggerUsage("bd");    
 }
 
-void debuggerBreak(int n, char **args)
+static void debuggerBreak(int n, char **args)
 {
   if(n == 2) {
     u32 address = 0;
@@ -914,7 +1007,7 @@
     debuggerUsage("break");  
 }
 
-void debuggerBreakThumb(int n, char **args)
+static void debuggerBreakThumb(int n, char **args)
 {
   if(n == 2) {
     u32 address = 0;
@@ -930,7 +1023,7 @@
     debuggerUsage("bt");    
 }
 
-void debuggerBreakArm(int n, char **args)
+static void debuggerBreakArm(int n, char **args)
 {
   if(n == 2) {
     u32 address = 0;
@@ -946,34 +1039,130 @@
     debuggerUsage("ba");
 }
 
-void debuggerBreakOnWrite(u32 *mem, u32 oldvalue, u32 value, int size)
+/*extern*/ void debuggerBreakOnWrite(u32 address, u32 oldvalue, u32 value, 
+                                     int size, int t)
 {
-  u32 address = 0;
-  if(mem >= (u32*)&workRAM[0] && mem <= (u32*)&workRAM[0x3ffff])
-    address = 0x2000000 + ((u32)mem - (u32)&workRAM[0]);
-  else
-    address = 0x3000000 + ((u32)mem - (u32)&internalRAM[0]);
+  const char *type = "write";
+  if(t == 2)
+    type = "change";
 
   if(size == 2)
-    printf("Breakpoint (on write) address %08x old:%08x new:%08x\n", 
-           address, oldvalue, value);
+    printf("Breakpoint (on %s) address %08x old:%08x new:%08x\n", 
+           type, address, oldvalue, value);
   else if(size == 1)
-    printf("Breakpoint (on write) address %08x old:%04x new:%04x\n", 
-           address, (u16)oldvalue,(u16)value);
+    printf("Breakpoint (on %s) address %08x old:%04x new:%04x\n", 
+           type, address, (u16)oldvalue,(u16)value);
   else
-    printf("Breakpoint (on write) address %08x old:%02x new:%02x\n", 
-           address, (u8)oldvalue, (u8)value);
+    printf("Breakpoint (on %s) address %08x old:%02x new:%02x\n", 
+           type, address, (u8)oldvalue, (u8)value);
   debugger = true;
 }
 
-void debuggerBreakWriteClear(int n, char **args)
+static void debuggerBreakWriteClear(int n, char **args)
 {
-  memset(freezeWorkRAM, false, 0x40000);
-  memset(freezeInternalRAM, false, 0x8000);
-  printf("Cleared all break on write\n");
+  if(n == 3) {
+    u32 address = 0;
+    sscanf(args[1], "%x", &address);
+    int n = 0;
+    sscanf(args[2], "%d", &n);
+
+	if (! ((address >= 0x02000000 && address < 0x02040000) ||
+		  (address >= 0x03000000 && address < 0x03008000) ||
+      (address >= 0x05000000 && address < 0x05000400) ||
+		  (address >= 0x06000000 && address < 0x06018000) ||
+      (address >= 0x07000000 && address < 0x07000400))) { 
+	  printf("Invalid address: %08x\n", address);
+      return;
+  }
+    
+    u32 final = address + n;    
+    switch(address >> 24) {
+    case 2:
+      {
+        address &= 0x3ffff;
+        final &= 0x3ffff;
+        for(u32 i = address; i < final; i++)
+          if(freezeWorkRAM[i] == 1)
+            freezeWorkRAM[i] = 0;
+        printf("Cleared break on write from %08x to %08x\n",
+               0x2000000+address, 0x2000000+final);
+      }
+      break;
+    case 3:
+      {
+        address &= 0x7fff;
+        final &= 0x7fff;
+        for(u32 i = address; i < final; i++)
+          if(freezeInternalRAM[i] == 1)
+            freezeInternalRAM[i] = 0;
+        printf("Cleared break on write from %08x to %08x\n",
+               0x3000000+address, 0x3000000+final);
+      }
+      break;
+    case 5:
+      {
+        address &= 0x3ff;
+        final &= 0x3ff;
+        for(u32 i = address; i < final; i++)
+          if(freezePRAM[i] == 1)
+            freezePRAM[i] = 0;
+        printf("Cleared break on write from %08x to %08x\n",
+               0x5000000+address, 0x5000000+final);
+      }
+      break;
+	  case 6:
+      {
+        if (address > 0x6010000) {
+          address &= 0x17fff;
+          final &= 0x17fff;
+        } else {
+          address &= 0xffff;
+          final &= 0xffff;
+        }
+
+        for (u32 i = address; i < final; i++)
+          if(freezeVRAM[i] == 1)
+            freezeVRAM[i] = 0;
+        printf("Cleared break on write from %08x to %08x\n",
+               0x06000000+address, 0x06000000+final);
+      }
+      break;
+    case 7:
+      {
+        address &= 0x3ff;
+        final &= 0x3ff;
+        for(u32 i = address; i < final; i++)
+          if(freezeOAM[i] == 1)
+            freezeOAM[i] = 0;
+        printf("Cleared break on write from %08x to %08x\n",
+               0x7000000+address, 0x7000000+final);
+      }
+      break;
+    }
+  } else if(n == 1) {
+    int i;
+    for(i = 0; i < 0x40000; i++)
+      if(freezeWorkRAM[i] == 1)
+        freezeWorkRAM[i] = 0;
+    for(i = 0; i < 0x8000; i++)
+      if(freezeInternalRAM[i] == 1)
+        freezeInternalRAM[i] = 0;
+    for(i = 0; i < 0x400; i++)
+      if(freezePRAM[i] == 1)
+        freezePRAM[i] = 0;
+    for(i = 0; i< 0x18000; i++)
+      if(freezeVRAM[i] == 1)
+        freezeVRAM[i] = 0;
+    for(i = 0; i < 0x400; i++)
+      if(freezeOAM[i] == 1)
+        freezeOAM[i] = 0;
+
+    printf("Cleared all break on write\n");
+  } else
+    debuggerUsage("bpwc");
 }
 
-void debuggerBreakWrite(int n, char **args)
+static void debuggerBreakWrite(int n, char **args)
 {
   if(n == 3) {
     if(cheatsNumber != 0) {
